USE Master; 
GO

--> DROP DATABASE Hekaton_Test 

CREATE DATABASE Hekaton_Test 
ON PRIMARY
( 
    NAME = [PRIMARY] , 
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL12.SQL2014\MSSQL\DATA\Hekaton_DiskBasedTable.mdf'
), 
FILEGROUP Hekaton_InMemory_FG CONTAINS MEMORY_OPTIMIZED_DATA
( 
NAME = [Hekaton_InMemory_Dir] , 
FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL12.SQL2014\MSSQL\DATA\In_Memory_Table'
)
LOG ON
(
    NAME = [Hekaton_log] ,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL12.SQL2014\MSSQL\DATA\Hekaton_Test_log.ldf'
);   
GO


USE Hekaton_Test;   
GO 

Create table MemoryTable 
(  
    id int not null PRIMARY KEY NONCLUSTERED HASH WITH(BUCKET_COUNT = 5000000)  ,
    Nome varchar(25) COLLATE Latin1_General_100_BIN2 not null ,
    Cognome varchar(50) COLLATE Latin1_General_100_BIN2 not null ,
    Indirizzo varchar(50) COLLATE Latin1_General_100_BIN2  
    INDEX inMemoryIdx NONCLUSTERED HASH (Cognome,Nome) WITH(BUCKET_COUNT = 5000000)  
)
WITH (MEMORY_OPTIMIZED = ON, DURABILITY = SCHEMA_ONLY);  
GO

USE Hekaton_Test;  
GO 
Create Table DiskTable 
(  
    id int Primary Key Clustered  ,
    Nome varchar(25)  ,
    Cognome varchar(50)  ,
    Indirizzo varchar(50)  
INDEX OnDiskIdx NONCLUSTERED (Cognome,Nome) 
) ON [PRIMARY] 
GO



USE Hekaton_Test;   
GO   
--Tabella Disk Based   
SET STATISTICS IO ON;
SET STATISTICS TIME ON;
WITH Cte
    AS ( SELECT 1 Riga
         UNION ALL
         SELECT 1
       ) , Cte4
    AS ( SELECT A.Riga
           FROM Cte A , Cte B
       ) , Cte16
    AS ( SELECT A.Riga
           FROM Cte4 A , Cte4 B
       ) , Cte256
    AS ( SELECT A.Riga
           FROM Cte16 A , Cte16 B
       ) , Cte65536
    AS ( SELECT A.Riga
           FROM Cte256 A , Cte256 B
       ) , CteMany
    AS ( SELECT A.Riga
           FROM Cte65536 A , Cte65536 B
       ) , Results
    AS ( SELECT ROW_NUMBER()OVER( ORDER BY Riga )Riga
           FROM CteMany
       )
    INSERT INTO  DiskTable( id , 
                                nome , 
                                Cognome , 
                                indirizzo
                              )
    SELECT Riga , 
           'Nome ' + CAST( Riga AS char( 8 ) ) , 
           'Cognome ' + CAST( Riga AS char( 8 ) ) , 
           'Indirizzo ' + CAST( Riga AS char( 8 ) )
      FROM Results
      WHERE Riga <= 50000;
SET STATISTICS IO OFF;
SET STATISTICS TIME OFF;
 
--Tabella In-Memory   
SET STATISTICS IO ON;
SET STATISTICS TIME ON;
WITH Cte
    AS ( SELECT 1 Riga
         UNION ALL
         SELECT 1
       ) , Cte4
    AS ( SELECT A.Riga
           FROM Cte A , Cte B
       ) , Cte16
    AS ( SELECT A.Riga
           FROM Cte4 A , Cte4 B
       ) , Cte256
    AS ( SELECT A.Riga
           FROM Cte16 A , Cte16 B
       ) , Cte65536
    AS ( SELECT A.Riga
           FROM Cte256 A , Cte256 B
       ) , CteMany
    AS ( SELECT A.Riga
           FROM Cte65536 A , Cte65536 B
       ) , Results
    AS ( SELECT ROW_NUMBER() OVER( ORDER BY Riga )Riga
           FROM CteMany
       )
    INSERT INTO  MemoryTable( id , 
                                  nome , 
                                  Cognome , 
                                  indirizzo
                                )
    SELECT Riga , 
           'Nome ' + CAST( Riga AS char( 8 ) ) , 
           'Cognome ' + CAST( Riga AS char( 8 ) ) , 
           'Indirizzo ' + CAST( Riga AS char( 8 ) )
      FROM Results
      WHERE Riga <= 50000;
SET STATISTICS IO OFF;
SET STATISTICS TIME OFF;
GO

