
USE Hekaton_Test;   
GO 


DROP TABLE dbo.MemoryTable
GO

--Creo la tabella 
CREATE TABLE dbo.MemoryTable
( 
    id int NOT NULL PRIMARY KEY NONCLUSTERED HASH
                    WITH( BUCKET_COUNT = 65536 ) , 
    campo varchar( 25 )COLLATE Latin1_General_100_BIN2 NOT NULL 
 )
 WITH
 ( 
    MEMORY_OPTIMIZED = ON , 
    DURABILITY = SCHEMA_AND_DATA
); 
GO   

--La popolo 
WITH Cte
    AS ( SELECT 1 Riga
         UNION ALL
         SELECT 1
       ) , Cte4
    AS ( SELECT A.Riga
           FROM Cte A , cte B
       ) , Cte16
    AS ( SELECT A.Riga
           FROM Cte4 A , Cte4 B
       ) , Cte256
    AS ( SELECT A.Riga
           FROM Cte16 A , Cte16 B
       ) , Cte65536
    AS ( SELECT A.Riga
           FROM Cte256 A , Cte256 B
       ) , results
    AS ( SELECT ROW_NUMBER(
                          )OVER( ORDER BY Riga
                               )Riga
           FROM Cte65536
       )
    INSERT INTO  MemoryTable
    SELECT Riga , 
           'Valore ' + CAST( Riga AS varchar( 5 )
    )
    FROM results; 
GO



--Creo una Stored Procedure tradizionale 
CREATE PROCEDURE Dbo.SP_TSQL_MEMORY_TAB  
    @id int
AS 
    DECLARE @c varchar(25);
    SELECT @c = A.campo
	 FROM dbo.Memorytable A
	 WHERE A.id = @id;

    UPDATE dbo.Memorytable
    SET campo = campo + 'AAAA'
	 WHERE id = @id;

    DELETE FROM dbo.Memorytable
	 WHERE id = @id;

    INSERT INTO dbo.Memorytable
    VALUES( @id , @c); 
GO   
	 
--Creo una Natively Compiled Stored Procedure 
CREATE PROCEDURE Dbo.SP_NATIVE_COMPILATION_MEMORY_TAB  
    @id int not null
WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS SELF AS
BEGIN ATOMIC WITH( TRANSACTION ISOLATION LEVEL = SNAPSHOT , LANGUAGE = 'us_english' )

    DECLARE @c varchar(25);
    SELECT @c = A.campo
	 FROM dbo.Memorytable A
	 WHERE A.id = @id;

    UPDATE dbo.Memorytable
    SET campo = campo + 'AAAA'
	 WHERE id = @id;

    DELETE FROM dbo.Memorytable
	 WHERE id = @id;

    INSERT INTO dbo.Memorytable
    VALUES( @id , @c);
END;
GO



-- 1 test
DECLARE
   @t datetime;
SET @t = GETDATE();
DECLARE
   @i int = 1; While @i <= 30000 
begin
    Exec sp_executesql N'Dbo.SP_TSQL_MEMORY_TAB @i',N'@i int',@i=@i  Set @i+=1   
end
select DATEDIFF( MILLISECOND , @t , current_timestamp );
GO


--2 test
DECLARE @t datetime;
SET @t = GETDATE();
DECLARE @i int = 1; 
While @i <= 30000 
begin      
    Exec sp_executesql N'Dbo.SP_NATIVE_COMPILATION_MEMORY_TAB @i',N'@i int',@i=@i  
Set @i+=1   
end
select DATEDIFF( MILLISECOND , @t , current_timestamp );
GO
